//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

extension API.ApiAlerte {

    /** Permet la déclaration d'une alerte de sécurité dans le vsoisinage */
    public enum PostApiAlerteInitialiser {

        public static let service = APIService<Response>(id: "postApiAlerteInitialiser", tag: "Api Alerte", method: "POST", path: "/apiAlerte/initialiser", hasBody: false)

        /** Permet la déclaration d'une alerte de sécurité dans le vsoisinage */
        public enum TypeEvenement: String {
            case actsoupcon = "ACT_SOUPCON"
            case actdangeravere = "ACT_DANGER_AVERE"
            case actconfirme = "ACT_CONFIRME"
            case actannule = "ACT_ANNULE"
            case obsdanger = "OBS_DANGER"
            case obscallok = "OBS_CALLOK"
            case obsras = "OBS_RAS"
            case obspolice = "OBS_POLICE"
            case obsokmerci = "OBS_OKMERCI"
            case obsverif = "OBS_VERIF"

            public static let cases: [TypeEvenement] = [
              .actsoupcon,
              .actdangeravere,
              .actconfirme,
              .actannule,
              .obsdanger,
              .obscallok,
              .obsras,
              .obspolice,
              .obsokmerci,
              .obsverif,
            ]
        }

        /** Permet la déclaration d'une alerte de sécurité dans le vsoisinage */
        public enum TypeAlerte: String {
            case cambriolage = "CAMBRIOLAGE"
            case incendie = "INCENDIE"
            case detresse = "DETRESSE"

            public static let cases: [TypeAlerte] = [
              .cambriolage,
              .incendie,
              .detresse,
            ]
        }

        public final class Request: APIRequest<Response> {

            public struct Options {

                public var identifiantUniqueEmetteur: String

                public var identifiantUniqueImpacte: String

                public var typeEvenement: TypeEvenement

                public var typeAlerte: TypeAlerte?

                public init(identifiantUniqueEmetteur: String, identifiantUniqueImpacte: String, typeEvenement: TypeEvenement, typeAlerte: TypeAlerte? = nil) {
                    self.identifiantUniqueEmetteur = identifiantUniqueEmetteur
                    self.identifiantUniqueImpacte = identifiantUniqueImpacte
                    self.typeEvenement = typeEvenement
                    self.typeAlerte = typeAlerte
                }
            }

            public var options: Options

            public init(options: Options) {
                self.options = options
                super.init(service: PostApiAlerteInitialiser.service)
            }

            /// convenience initialiser so an Option doesn't have to be created
            public convenience init(identifiantUniqueEmetteur: String, identifiantUniqueImpacte: String, typeEvenement: TypeEvenement, typeAlerte: TypeAlerte? = nil) {
                let options = Options(identifiantUniqueEmetteur: identifiantUniqueEmetteur, identifiantUniqueImpacte: identifiantUniqueImpacte, typeEvenement: typeEvenement, typeAlerte: typeAlerte)
                self.init(options: options)
            }

            public override var parameters: [String: Any] {
                var params: JSONDictionary = [:]
                params["identifiantUniqueEmetteur"] = options.identifiantUniqueEmetteur
                params["identifiantUniqueImpacte"] = options.identifiantUniqueImpacte
                params["typeEvenement"] = options.typeEvenement.encode()
                if let typeAlerte = options.typeAlerte?.encode() {
                  params["typeAlerte"] = typeAlerte
                }
                return params
            }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = Void

            /** OK */
            case status200

            /** Erreur */
            case status400

            /** Erreur */
            case status500

            public var success: Void? {
                switch self {
                case .status200: return ()
                default: return nil
                }
            }

            public var response: Any {
                switch self {
                default: return ()
                }
            }

            public var statusCode: Int {
                switch self {
                case .status200: return 200
                case .status400: return 400
                case .status500: return 500
                }
            }

            public var successful: Bool {
                switch self {
                case .status200: return true
                case .status400: return false
                case .status500: return false
                }
            }

            public init(statusCode: Int, data: Data) throws {
                switch statusCode {
                case 200: self = .status200
                case 400: self = .status400
                case 500: self = .status500
                default: throw APIError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
